[ProdigyMathGameHackingTypings](../README.md) › [Globals](../globals.md) › ["player.d"](../modules/_player_d_.md) › [Player](_player_d_.player.md)

# Class: Player

## Hierarchy

* **Player**

## Index

### Constructors

* [constructor](_player_d_.player.md#constructor)

### Properties

* [MAX_HEARTS](_player_d_.player.md#max_hearts)
* [_isFocusModeEnabled](_player_d_.player.md#_isfocusmodeenabled)
* [_remoteLogger](_player_d_.player.md#_remotelogger)
* [_saveEnabled](_player_d_.player.md#_saveenabled)
* [achievements](_player_d_.player.md#achievements)
* [appearance](_player_d_.player.md#appearance)
* [appearanceChanged](_player_d_.player.md#appearancechanged)
* [backpack](_player_d_.player.md#backpack)
* [broadcastId](_player_d_.player.md#broadcastid)
* [catchAttempt](_player_d_.player.md#catchattempt)
* [chatID](_player_d_.player.md#chatid)
* [classIDs](_player_d_.player.md#classids)
* [coOpTeam](_player_d_.player.md#optional-coopteam)
* [currentVideoSkillId](_player_d_.player.md#optional-currentvideoskillid)
* [curriculumTreeID](_player_d_.player.md#curriculumtreeid)
* [daily](_player_d_.player.md#daily)
* [dailyQuestions](_player_d_.player.md#dailyquestions)
* [danceID](_player_d_.player.md#optional-danceid)
* [data](_player_d_.player.md#data)
* [earlyBirdLastChance](_player_d_.player.md#earlybirdlastchance)
* [emoteID](_player_d_.player.md#optional-emoteid)
* [encounters](_player_d_.player.md#encounters)
* [equipment](_player_d_.player.md#equipment)
* [game](_player_d_.player.md#game)
* [grade](_player_d_.player.md#grade)
* [hasUsedTicket](_player_d_.player.md#hasusedticket)
* [house](_player_d_.player.md#house)
* [immortal](_player_d_.player.md#immortal)
* [inPVP](_player_d_.player.md#inpvp)
* [isClassCodeAttached](_player_d_.player.md#isclasscodeattached)
* [isFocusModeEnabled](_player_d_.player.md#isfocusmodeenabled)
* [isOpponent](_player_d_.player.md#isopponent)
* [it](_player_d_.player.md#it)
* [justLeveled](_player_d_.player.md#justleveled)
* [kennel](_player_d_.player.md#kennel)
* [lastVisited](_player_d_.player.md#lastvisited)
* [locationSelectionType](_player_d_.player.md#locationselectiontype)
* [memberEndDate](_player_d_.player.md#optional-memberenddate)
* [memberPrompt](_player_d_.player.md#memberprompt)
* [memberShareDate](_player_d_.player.md#optional-membersharedate)
* [memberStartDate](_player_d_.player.md#optional-memberstartdate)
* [modifiers](_player_d_.player.md#modifiers)
* [name](_player_d_.player.md#name)
* [onHPChange](_player_d_.player.md#onhpchange)
* [overrideClassSelect](_player_d_.player.md#overrideclassselect)
* [owners](_player_d_.player.md#owners)
* [parentEmail](_player_d_.player.md#parentemail)
* [parentalLink](_player_d_.player.md#parentallink)
* [password](_player_d_.player.md#password)
* [playerParents](_player_d_.player.md#playerparents)
* [playerTeachers](_player_d_.player.md#playerteachers)
* [pvpHP](_player_d_.player.md#pvphp)
* [quests](_player_d_.player.md#quests)
* [registerDate](_player_d_.player.md#registerdate)
* [saveEnabled](_player_d_.player.md#saveenabled)
* [source](_player_d_.player.md#optional-source)
* [spellStreak](_player_d_.player.md#spellstreak)
* [starsEarned](_player_d_.player.md#starsearned)
* [starsReward](_player_d_.player.md#starsreward)
* [starsRewardBase](_player_d_.player.md#starsrewardbase)
* [starsToProcess](_player_d_.player.md#starstoprocess)
* [state](_player_d_.player.md#state)
* [team](_player_d_.player.md#optional-team)
* [transformID](_player_d_.player.md#optional-transformid)
* [tutorialCompletedThisSession](_player_d_.player.md#tutorialcompletedthissession)
* [type](_player_d_.player.md#type)
* [updated](_player_d_.player.md#updated)
* [userID](_player_d_.player.md#userid)
* [username](_player_d_.player.md#username)
* [world](_player_d_.player.md#world)
* [ACCOUNT_RESET_ZONE_KEEPERS](_player_d_.player.md#static-account_reset_zone_keepers)
* [HP_BONUS](_player_d_.player.md#static-hp_bonus)
* [LEVEL_CURVE](_player_d_.player.md#static-level_curve)

### Methods

* [addAsset](_player_d_.player.md#addasset)
* [addBattle](_player_d_.player.md#addbattle)
* [addBountyScore](_player_d_.player.md#addbountyscore)
* [addLoss](_player_d_.player.md#addloss)
* [addSpell](_player_d_.player.md#addspell)
* [addStars](_player_d_.player.md#addstars)
* [addWin](_player_d_.player.md#addwin)
* [anyPetsAboveLevel](_player_d_.player.md#anypetsabovelevel)
* [canCatch](_player_d_.player.md#cancatch)
* [canSpin](_player_d_.player.md#canspin)
* [castSpell](_player_d_.player.md#castspell)
* [changeCurrentHearts](_player_d_.player.md#changecurrenthearts)
* [changeCurrentHeartsPercent](_player_d_.player.md#changecurrentheartspercent)
* [changeEnergy](_player_d_.player.md#changeenergy)
* [changeGold](_player_d_.player.md#changegold)
* [checkVersion](_player_d_.player.md#checkversion)
* [completeDaily](_player_d_.player.md#completedaily)
* [completeTower](_player_d_.player.md#completetower)
* [createDataClone](_player_d_.player.md#createdataclone)
* [createRandom](_player_d_.player.md#createrandom)
* [diffAttackSlots](_player_d_.player.md#diffattackslots)
* [equip](_player_d_.player.md#equip)
* [evolve](_player_d_.player.md#evolve)
* [forceSaveCharacter](_player_d_.player.md#forcesavecharacter)
* [getAllAttacks](_player_d_.player.md#getallattacks)
* [getAllowsHouseVisitors](_player_d_.player.md#getallowshousevisitors)
* [getArenaPoints](_player_d_.player.md#getarenapoints)
* [getAttacks](_player_d_.player.md#getattacks)
* [getAvailableEvolutions](_player_d_.player.md#getavailableevolutions)
* [getBaseMaxHearts](_player_d_.player.md#getbasemaxhearts)
* [getBattles](_player_d_.player.md#getbattles)
* [getBountyScore](_player_d_.player.md#getbountyscore)
* [getColiseum](_player_d_.player.md#getcoliseum)
* [getCurrentBamSpells](_player_d_.player.md#getcurrentbamspells)
* [getCurrentHearts](_player_d_.player.md#getcurrenthearts)
* [getDailyQuestions](_player_d_.player.md#getdailyquestions)
* [getDamageBonus](_player_d_.player.md#getdamagebonus)
* [getDataAndClear](_player_d_.player.md#getdataandclear)
* [getElement](_player_d_.player.md#getelement)
* [getEnergy](_player_d_.player.md#getenergy)
* [getEquipmentSpell](_player_d_.player.md#getequipmentspell)
* [getFirstName](_player_d_.player.md#getfirstname)
* [getGold](_player_d_.player.md#getgold)
* [getHeartBonus](_player_d_.player.md#getheartbonus)
* [getID](_player_d_.player.md#getid)
* [getLatestClassIDLegacy](_player_d_.player.md#getlatestclassidlegacy)
* [getLevel](_player_d_.player.md#getlevel)
* [getLevelingCurve](_player_d_.player.md#getlevelingcurve)
* [getLosses](_player_d_.player.md#getlosses)
* [getMaxHearts](_player_d_.player.md#getmaxhearts)
* [getMaxTimeForCurrentMorphMarbleEffect](_player_d_.player.md#getmaxtimeforcurrentmorphmarbleeffect)
* [getName](_player_d_.player.md#getname)
* [getNameWithoutNickname](_player_d_.player.md#getnamewithoutnickname)
* [getNativeSpell](_player_d_.player.md#getnativespell)
* [getNumAttacks](_player_d_.player.md#getnumattacks)
* [getNumRelics](_player_d_.player.md#getnumrelics)
* [getPercentToLevel](_player_d_.player.md#getpercenttolevel)
* [getPlayerClass](_player_d_.player.md#getplayerclass)
* [getPlayerData](_player_d_.player.md#getplayerdata)
* [getRegisterDate](_player_d_.player.md#getregisterdate)
* [getSettings](_player_d_.player.md#getsettings)
* [getSpellAssets](_player_d_.player.md#getspellassets)
* [getSpellStreak](_player_d_.player.md#getspellstreak)
* [getStarReward](_player_d_.player.md#getstarreward)
* [getStarRewardByDamage](_player_d_.player.md#getstarrewardbydamage)
* [getStars](_player_d_.player.md#getstars)
* [getStarsToLevel](_player_d_.player.md#getstarstolevel)
* [getStatHealth](_player_d_.player.md#getstathealth)
* [getStatPower](_player_d_.player.md#getstatpower)
* [getTeamScore](_player_d_.player.md#getteamscore)
* [getTowerProgress](_player_d_.player.md#gettowerprogress)
* [getUpdatedData](_player_d_.player.md#getupdateddata)
* [getWins](_player_d_.player.md#getwins)
* [hasCompletedTowerTownTutorial](_player_d_.player.md#hascompletedtowertowntutorial)
* [hasCompletedTutorial](_player_d_.player.md#hascompletedtutorial)
* [hasHouseItem](_player_d_.player.md#hashouseitem)
* [hasMaxQuantityOfItem](_player_d_.player.md#hasmaxquantityofitem)
* [hasMembership](_player_d_.player.md#hasmembership)
* [hasValidatedParentEmail](_player_d_.player.md#hasvalidatedparentemail)
* [hasValidatedTeacherEmail](_player_d_.player.md#hasvalidatedteacheremail)
* [heal](_player_d_.player.md#heal)
* [healTeam](_player_d_.player.md#healteam)
* [healTeamMember](_player_d_.player.md#healteammember)
* [init](_player_d_.player.md#init)
* [initFromProtobuf](_player_d_.player.md#initfromprotobuf)
* [isBlockedByDarkTowerMemberGate](_player_d_.player.md#isblockedbydarktowermembergate)
* [isItemOwned](_player_d_.player.md#isitemowned)
* [isKnockedOut](_player_d_.player.md#isknockedout)
* [isPlayerTransformed](_player_d_.player.md#isplayertransformed)
* [onTutorialComplete](_player_d_.player.md#ontutorialcomplete)
* [processDeserter](_player_d_.player.md#processdeserter)
* [processStars](_player_d_.player.md#processstars)
* [processTrialMembership](_player_d_.player.md#processtrialmembership)
* [resetAccount](_player_d_.player.md#resetaccount)
* [resetModifiers](_player_d_.player.md#resetmodifiers)
* [rewardMembershipPrizes](_player_d_.player.md#rewardmembershipprizes)
* [setAllowsHouseVisitors](_player_d_.player.md#setallowshousevisitors)
* [setBGMVolume](_player_d_.player.md#setbgmvolume)
* [setColiseum](_player_d_.player.md#setcoliseum)
* [setData](_player_d_.player.md#setdata)
* [setDefault](_player_d_.player.md#setdefault)
* [setEnergy](_player_d_.player.md#setenergy)
* [setMemberDebug](_player_d_.player.md#setmemberdebug)
* [setMembership](_player_d_.player.md#setmembership)
* [setParentEmail](_player_d_.player.md#setparentemail)
* [setPlayerClass](_player_d_.player.md#setplayerclass)
* [setSFXVolume](_player_d_.player.md#setsfxvolume)
* [setSpinDate](_player_d_.player.md#setspindate)
* [setVoiceVolume](_player_d_.player.md#setvoicevolume)
* [setZone](_player_d_.player.md#setzone)
* [spinWheel](_player_d_.player.md#spinwheel)
* [swapSpells](_player_d_.player.md#swapspells)
* [transformPlayer](_player_d_.player.md#transformplayer)
* [unequip](_player_d_.player.md#unequip)
* [updateMembershipVideoAdData](_player_d_.player.md#updatemembershipvideoaddata)
* [updateModifier](_player_d_.player.md#updatemodifier)
* [validateLevel](_player_d_.player.md#validatelevel)
* [enemiesPerLevel](_player_d_.player.md#static-enemiesperlevel)
* [getAoeEvolutions](_player_d_.player.md#static-getaoeevolutions)
* [getAttacksFromCurve](_player_d_.player.md#static-getattacksfromcurve)
* [getAttacksOfType](_player_d_.player.md#static-getattacksoftype)
* [getEvolutionsFromCurve](_player_d_.player.md#static-getevolutionsfromcurve)
* [getHeartsFromCurve](_player_d_.player.md#static-getheartsfromcurve)
* [getLevelPercent](_player_d_.player.md#static-getlevelpercent)
* [getSingleShotEvolutions](_player_d_.player.md#static-getsingleshotevolutions)
* [levelFromStars](_player_d_.player.md#static-levelfromstars)
* [starsToLevel](_player_d_.player.md#static-starstolevel)

## Constructors

###  constructor

\+ **new Player**(`prop0`: unknown): *[Player](_player_d_.player.md)*

**Parameters:**

Name | Type |
------ | ------ |
`prop0` | unknown |

**Returns:** *[Player](_player_d_.player.md)*

## Properties

###  MAX_HEARTS

• **MAX_HEARTS**: *number*

___

###  _isFocusModeEnabled

• **_isFocusModeEnabled**: *false*

___

###  _remoteLogger

• **_remoteLogger**: *[TODO](../modules/_util_d_.md#todo)*

___

###  _saveEnabled

• **_saveEnabled**: *true*

___

###  achievements

• **achievements**: *[TODO](../modules/_util_d_.md#todo)*

___

###  appearance

• **appearance**: *[TODO](../modules/_util_d_.md#todo)*

___

###  appearanceChanged

• **appearanceChanged**: *boolean*

___

###  backpack

• **backpack**: *[TODO](../modules/_util_d_.md#todo)*

___

###  broadcastId

• **broadcastId**: *number*

___

###  catchAttempt

• **catchAttempt**: *number*

___

###  chatID

• **chatID**: *number*

___

###  classIDs

• **classIDs**: *number[]*

___

### `Optional` coOpTeam

• **coOpTeam**? : *unknown*

___

### `Optional` currentVideoSkillId

• **currentVideoSkillId**? : *unknown*

___

###  curriculumTreeID

• **curriculumTreeID**: *number*

___

###  daily

• **daily**: *[TODO](../modules/_util_d_.md#todo)*

___

###  dailyQuestions

• **dailyQuestions**: *[TODO](../modules/_util_d_.md#todo)*

___

### `Optional` danceID

• **danceID**? : *unknown*

___

###  data

• **data**: *[PlayerData](_player_d_.playerdata.md)*

___

###  earlyBirdLastChance

• **earlyBirdLastChance**: *boolean*

___

### `Optional` emoteID

• **emoteID**? : *unknown*

___

###  encounters

• **encounters**: *[TODO](../modules/_util_d_.md#todo)*

___

###  equipment

• **equipment**: *[TODO](../modules/_util_d_.md#todo)*

___

###  game

• **game**: *[Game](../interfaces/_game_d_.game.md)*

___

###  grade

• **grade**: *number*

___

###  hasUsedTicket

• **hasUsedTicket**: *boolean*

___

###  house

• **house**: *[TODO](../modules/_util_d_.md#todo)*

___

###  immortal

• **immortal**: *boolean*

___

###  inPVP

• **inPVP**: *boolean*

___

###  isClassCodeAttached

• **isClassCodeAttached**: *boolean*

___

###  isFocusModeEnabled

• **isFocusModeEnabled**: *boolean*

___

###  isOpponent

• **isOpponent**: *boolean*

___

###  it

• **it**: *boolean*

Membership

___

###  justLeveled

• **justLeveled**: *boolean*

___

###  kennel

• **kennel**: *[TODO](../modules/_util_d_.md#todo)*

___

###  lastVisited

• **lastVisited**: *string*

A date ISOString

___

###  locationSelectionType

• **locationSelectionType**: *string*

___

### `Optional` memberEndDate

• **memberEndDate**? : *unknown*

___

###  memberPrompt

• **memberPrompt**: *boolean*

___

### `Optional` memberShareDate

• **memberShareDate**? : *unknown*

___

### `Optional` memberStartDate

• **memberStartDate**? : *string*

A date ISOString

___

###  modifiers

• **modifiers**: *object*

#### Type declaration:

* **damage**: *number*

* **ignoreElement**: *number*

* **maxHearts**: *number*

* **miss**: *number*

* **potion**? : *unknown*

___

###  name

• **name**: *[PlayerName](../interfaces/_player_d_.playername.md)*

___

###  onHPChange

• **onHPChange**: *[TODO](../modules/_util_d_.md#todo)*

___

###  overrideClassSelect

• **overrideClassSelect**: *boolean*

___

###  owners

• **owners**: *object[]*

___

###  parentEmail

• **parentEmail**: *string*

___

###  parentalLink

• **parentalLink**: *boolean*

___

###  password

• **password**: *string*

___

###  playerParents

• **playerParents**: *unknown[]*

___

###  playerTeachers

• **playerTeachers**: *object[]*

___

###  pvpHP

• **pvpHP**: *number*

___

###  quests

• **quests**: *[TODO](../modules/_util_d_.md#todo)*

___

###  registerDate

• **registerDate**: *Date*

___

###  saveEnabled

• **saveEnabled**: *boolean*

___

### `Optional` source

• **source**? : *unknown*

___

###  spellStreak

• **spellStreak**: *number*

___

###  starsEarned

• **starsEarned**: *number*

___

###  starsReward

• **starsReward**: *number*

___

###  starsRewardBase

• **starsRewardBase**: *number*

___

###  starsToProcess

• **starsToProcess**: *number*

___

###  state

• **state**: *[TODO](../modules/_util_d_.md#todo)*

___

### `Optional` team

• **team**? : *unknown*

___

### `Optional` transformID

• **transformID**? : *unknown*

___

###  tutorialCompletedThisSession

• **tutorialCompletedThisSession**: *boolean*

___

###  type

• **type**: *string*

___

###  updated

• **updated**: *boolean*

___

###  userID

• **userID**: *number*

___

###  username

• **username**: *string*

___

###  world

• **world**: *object*

#### Type declaration:

* **count**: *number*

* **full**: *number*

* **id**: *number*

* **meta**: *unknown*

* **name**: *string*

___

### `Static` ACCOUNT_RESET_ZONE_KEEPERS

▪ **ACCOUNT_RESET_ZONE_KEEPERS**: *[Zones](../modules/_player_d_.md#zones)[]*

___

### `Static` HP_BONUS

▪ **HP_BONUS**: *object*

#### Type declaration:

* **A**: *number*

* **A+**: *number*

* **A-**: *number*

* **B**: *number*

* **B+**: *number*

* **B-**: *number*

* **C**: *number*

* **C+**: *number*

* **C-**: *number*

___

### `Static` LEVEL_CURVE

▪ **LEVEL_CURVE**: *object[]*

## Methods

###  addAsset

▸ **addAsset**(`asset`: unknown): *void*

**Parameters:**

Name | Type |
------ | ------ |
`asset` | unknown |

**Returns:** *void*

___

###  addBattle

▸ **addBattle**(): *void*

**Returns:** *void*

___

###  addBountyScore

▸ **addBountyScore**(`bountyScore`: number): *void*

**Parameters:**

Name | Type |
------ | ------ |
`bountyScore` | number |

**Returns:** *void*

___

###  addLoss

▸ **addLoss**(): *void*

**Returns:** *void*

___

###  addSpell

▸ **addSpell**(`spell`: number): *void*

**Parameters:**

Name | Type |
------ | ------ |
`spell` | number |

**Returns:** *void*

___

###  addStars

▸ **addStars**(`stars`: number, `prop1`: boolean, `prop2`: boolean): *boolean*

**Parameters:**

Name | Type |
------ | ------ |
`stars` | number |
`prop1` | boolean |
`prop2` | boolean |

**Returns:** *boolean*

___

###  addWin

▸ **addWin**(): *void*

**Returns:** *void*

___

###  anyPetsAboveLevel

▸ **anyPetsAboveLevel**(`level`: number): *boolean*

**Parameters:**

Name | Type |
------ | ------ |
`level` | number |

**Returns:** *boolean*

___

###  canCatch

▸ **canCatch**(): *boolean*

**Returns:** *boolean*

___

###  canSpin

▸ **canSpin**(): *boolean*

**Returns:** *boolean*

___

###  castSpell

▸ **castSpell**(`prop0`: boolean): *void*

**Parameters:**

Name | Type |
------ | ------ |
`prop0` | boolean |

**Returns:** *void*

___

###  changeCurrentHearts

▸ **changeCurrentHearts**(`prop0`: number, `prop1`: number): *void*

**Parameters:**

Name | Type |
------ | ------ |
`prop0` | number |
`prop1` | number |

**Returns:** *void*

___

###  changeCurrentHeartsPercent

▸ **changeCurrentHeartsPercent**(`percent`: number): *void*

**Parameters:**

Name | Type |
------ | ------ |
`percent` | number |

**Returns:** *void*

___

###  changeEnergy

▸ **changeEnergy**(`energy`: number): *void*

**Parameters:**

Name | Type |
------ | ------ |
`energy` | number |

**Returns:** *void*

___

###  changeGold

▸ **changeGold**(`gold`: number, `prop1`: boolean): *void*

**Parameters:**

Name | Type |
------ | ------ |
`gold` | number |
`prop1` | boolean |

**Returns:** *void*

___

###  checkVersion

▸ **checkVersion**(): *void*

**Returns:** *void*

___

###  completeDaily

▸ **completeDaily**(`daily`: keyof PlayerData, `completed`: boolean): *void*

**Parameters:**

Name | Type |
------ | ------ |
`daily` | keyof PlayerData |
`completed` | boolean |

**Returns:** *void*

___

###  completeTower

▸ **completeTower**(`tower`: number): *void*

**Parameters:**

Name | Type |
------ | ------ |
`tower` | number |

**Returns:** *void*

___

###  createDataClone

▸ **createDataClone**(): *[Player](_player_d_.player.md)*

**Returns:** *[Player](_player_d_.player.md)*

___

###  createRandom

▸ **createRandom**(): *void*

**Returns:** *void*

___

###  diffAttackSlots

▸ **diffAttackSlots**(`level`: number): *void*

**Parameters:**

Name | Type |
------ | ------ |
`level` | number |

**Returns:** *void*

___

###  equip

▸ **equip**(`id`: number, `type`: [ItemType](../modules/_player_d_.md#itemtype)): *boolean*

**Parameters:**

Name | Type |
------ | ------ |
`id` | number |
`type` | [ItemType](../modules/_player_d_.md#itemtype) |

**Returns:** *boolean*

___

###  evolve

▸ **evolve**(`unused0`: never, `unused1`: never): *never*

**Parameters:**

Name | Type |
------ | ------ |
`unused0` | never |
`unused1` | never |

**Returns:** *never*

___

###  forceSaveCharacter

▸ **forceSaveCharacter**(): *void*

**Returns:** *void*

___

###  getAllAttacks

▸ **getAllAttacks**(): *number[]*

**Returns:** *number[]*

___

###  getAllowsHouseVisitors

▸ **getAllowsHouseVisitors**(): *boolean*

**Returns:** *boolean*

___

###  getArenaPoints

▸ **getArenaPoints**(): *number*

**Returns:** *number*

___

###  getAttacks

▸ **getAttacks**(): *number[]*

**Returns:** *number[]*

___

###  getAvailableEvolutions

▸ **getAvailableEvolutions**(): *unknown[]*

**Returns:** *unknown[]*

___

###  getBaseMaxHearts

▸ **getBaseMaxHearts**(): *number*

**Returns:** *number*

___

###  getBattles

▸ **getBattles**(): *number*

**Returns:** *number*

___

###  getBountyScore

▸ **getBountyScore**(): *number*

**Returns:** *number*

___

###  getColiseum

▸ **getColiseum**(): *number*

**Returns:** *number*

___

###  getCurrentBamSpells

▸ **getCurrentBamSpells**(): *number[]*

**Returns:** *number[]*

___

###  getCurrentHearts

▸ **getCurrentHearts**(): *number*

**Returns:** *number*

___

###  getDailyQuestions

▸ **getDailyQuestions**(): *Player["dailyQuestions"]*

**Returns:** *Player["dailyQuestions"]*

___

###  getDamageBonus

▸ **getDamageBonus**(): *ReturnType‹Player["equipment"]["getDamageBonuses"]›*

**Returns:** *ReturnType‹Player["equipment"]["getDamageBonuses"]›*

___

###  getDataAndClear

▸ **getDataAndClear**(): *Partial‹[Player](_player_d_.player.md)›*

**Returns:** *Partial‹[Player](_player_d_.player.md)›*

___

###  getElement

▸ **getElement**(): *"wizard"*

**Returns:** *"wizard"*

___

###  getEnergy

▸ **getEnergy**(): *number*

**Returns:** *number*

___

###  getEquipmentSpell

▸ **getEquipmentSpell**(): *object*

**Returns:** *object*

* **ID**: *number*

* **locked**: *boolean*

* **type**: *unknown*

___

###  getFirstName

▸ **getFirstName**(): *string*

**Returns:** *string*

___

###  getGold

▸ **getGold**(): *number*

**Returns:** *number*

___

###  getHeartBonus

▸ **getHeartBonus**(): *number*

**Returns:** *number*

___

###  getID

▸ **getID**(): *Player["userID"]*

**Returns:** *Player["userID"]*

___

###  getLatestClassIDLegacy

▸ **getLatestClassIDLegacy**(): *number*

**Returns:** *number*

___

###  getLevel

▸ **getLevel**(): *number*

**Returns:** *number*

___

###  getLevelingCurve

▸ **getLevelingCurve**(`level`: number): *unknown[]*

**Parameters:**

Name | Type |
------ | ------ |
`level` | number |

**Returns:** *unknown[]*

___

###  getLosses

▸ **getLosses**(): *number*

**Returns:** *number*

___

###  getMaxHearts

▸ **getMaxHearts**(`level`: number): *number*

**Parameters:**

Name | Type |
------ | ------ |
`level` | number |

**Returns:** *number*

___

###  getMaxTimeForCurrentMorphMarbleEffect

▸ **getMaxTimeForCurrentMorphMarbleEffect**(): *number*

**Returns:** *number*

___

###  getName

▸ **getName**(): *string*

**Returns:** *string*

___

###  getNameWithoutNickname

▸ **getNameWithoutNickname**(): *string*

**Returns:** *string*

___

###  getNativeSpell

▸ **getNativeSpell**(`prop0`: unknown, `prop1`: unknown[], `prop2`: unknown, `prop3`: unknown): *unknown*

**Parameters:**

Name | Type |
------ | ------ |
`prop0` | unknown |
`prop1` | unknown[] |
`prop2` | unknown |
`prop3` | unknown |

**Returns:** *unknown*

___

###  getNumAttacks

▸ **getNumAttacks**(): *number*

**Returns:** *number*

___

###  getNumRelics

▸ **getNumRelics**(): *number*

**Returns:** *number*

___

###  getPercentToLevel

▸ **getPercentToLevel**(): *number*

**Returns:** *number*

___

###  getPlayerClass

▸ **getPlayerClass**(): *string*

**Returns:** *string*

___

###  getPlayerData

▸ **getPlayerData**(): *[PlayerData](_player_d_.playerdata.md)*

**Returns:** *[PlayerData](_player_d_.playerdata.md)*

___

###  getRegisterDate

▸ **getRegisterDate**(): *Date | null*

**Returns:** *Date | null*

___

###  getSettings

▸ **getSettings**(): *PlayerData["settings"]*

**Returns:** *PlayerData["settings"]*

___

###  getSpellAssets

▸ **getSpellAssets**(): *unknown[]*

**Returns:** *unknown[]*

___

###  getSpellStreak

▸ **getSpellStreak**(): *Player["spellStreak"]*

**Returns:** *Player["spellStreak"]*

___

###  getStarReward

▸ **getStarReward**(): *number*

**Returns:** *number*

___

###  getStarRewardByDamage

▸ **getStarRewardByDamage**(`damage`: number): *number*

**Parameters:**

Name | Type |
------ | ------ |
`damage` | number |

**Returns:** *number*

___

###  getStars

▸ **getStars**(): *number | null*

**Returns:** *number | null*

___

###  getStarsToLevel

▸ **getStarsToLevel**(): *number*

**Returns:** *number*

___

###  getStatHealth

▸ **getStatHealth**(): *number*

**Returns:** *number*

___

###  getStatPower

▸ **getStatPower**(): *number*

**Returns:** *number*

___

###  getTeamScore

▸ **getTeamScore**(): *number*

**Returns:** *number*

___

###  getTowerProgress

▸ **getTowerProgress**(): *number*

**Returns:** *number*

___

###  getUpdatedData

▸ **getUpdatedData**(`prop0`: unknown, `prop1`: unknown): *unknown*

**Parameters:**

Name | Type |
------ | ------ |
`prop0` | unknown |
`prop1` | unknown |

**Returns:** *unknown*

___

###  getWins

▸ **getWins**(): *number*

**Returns:** *number*

___

###  hasCompletedTowerTownTutorial

▸ **hasCompletedTowerTownTutorial**(): *boolean*

**Returns:** *boolean*

___

###  hasCompletedTutorial

▸ **hasCompletedTutorial**(): *boolean*

**Returns:** *boolean*

___

###  hasHouseItem

▸ **hasHouseItem**(`item`: [Item](../modules/_item_d_.md#item)): *boolean*

**Parameters:**

Name | Type |
------ | ------ |
`item` | [Item](../modules/_item_d_.md#item) |

**Returns:** *boolean*

___

###  hasMaxQuantityOfItem

▸ **hasMaxQuantityOfItem**(`type`: unknown, `item`: unknown): *boolean*

**Parameters:**

Name | Type |
------ | ------ |
`type` | unknown |
`item` | unknown |

**Returns:** *boolean*

___

###  hasMembership

▸ **hasMembership**(): *Player["it"]*

**Returns:** *Player["it"]*

___

###  hasValidatedParentEmail

▸ **hasValidatedParentEmail**(): *boolean*

**Returns:** *boolean*

___

###  hasValidatedTeacherEmail

▸ **hasValidatedTeacherEmail**(): *boolean*

**Returns:** *boolean*

___

###  heal

▸ **heal**(): *void*

**Returns:** *void*

___

###  healTeam

▸ **healTeam**(`hearts`: number): *void*

**Parameters:**

Name | Type |
------ | ------ |
`hearts` | number |

**Returns:** *void*

___

###  healTeamMember

▸ **healTeamMember**(`hearts`: number, `prop1`: unknown, `prop2`: unknown): *void*

**Parameters:**

Name | Type |
------ | ------ |
`hearts` | number |
`prop1` | unknown |
`prop2` | unknown |

**Returns:** *void*

___

###  init

▸ **init**(`prop0`: unknown): *unknown*

**Parameters:**

Name | Type |
------ | ------ |
`prop0` | unknown |

**Returns:** *unknown*

___

###  initFromProtobuf

▸ **initFromProtobuf**(`prop0`: unknown): *void*

**Parameters:**

Name | Type |
------ | ------ |
`prop0` | unknown |

**Returns:** *void*

___

###  isBlockedByDarkTowerMemberGate

▸ **isBlockedByDarkTowerMemberGate**(): *boolean*

**Returns:** *boolean*

___

###  isItemOwned

▸ **isItemOwned**(`item`: [Item](../modules/_item_d_.md#item)): *boolean*

**Parameters:**

Name | Type |
------ | ------ |
`item` | [Item](../modules/_item_d_.md#item) |

**Returns:** *boolean*

___

###  isKnockedOut

▸ **isKnockedOut**(): *boolean*

**Returns:** *boolean*

___

###  isPlayerTransformed

▸ **isPlayerTransformed**(): *boolean*

**Returns:** *boolean*

___

###  onTutorialComplete

▸ **onTutorialComplete**(): *void*

**Returns:** *void*

___

###  processDeserter

▸ **processDeserter**(): *void*

**Returns:** *void*

___

###  processStars

▸ **processStars**(): *void*

**Returns:** *void*

___

###  processTrialMembership

▸ **processTrialMembership**(): *void*

**Returns:** *void*

___

###  resetAccount

▸ **resetAccount**(): *void*

**Returns:** *void*

___

###  resetModifiers

▸ **resetModifiers**(): *void*

**Returns:** *void*

___

###  rewardMembershipPrizes

▸ **rewardMembershipPrizes**(`prop0`: unknown): *void*

**Parameters:**

Name | Type |
------ | ------ |
`prop0` | unknown |

**Returns:** *void*

___

###  setAllowsHouseVisitors

▸ **setAllowsHouseVisitors**(`allow`: boolean): *void*

**Parameters:**

Name | Type |
------ | ------ |
`allow` | boolean |

**Returns:** *void*

___

###  setBGMVolume

▸ **setBGMVolume**(`volume`: number): *void*

**Parameters:**

Name | Type |
------ | ------ |
`volume` | number |

**Returns:** *void*

___

###  setColiseum

▸ **setColiseum**(`coliseum`: number): *void*

**Parameters:**

Name | Type |
------ | ------ |
`coliseum` | number |

**Returns:** *void*

___

###  setData

▸ **setData**(`data`: [PlayerData](_player_d_.playerdata.md)): *void*

**Parameters:**

Name | Type |
------ | ------ |
`data` | [PlayerData](_player_d_.playerdata.md) |

**Returns:** *void*

___

###  setDefault

▸ **setDefault**(`gender`: "male" | "female"): *void*

**Parameters:**

Name | Type |
------ | ------ |
`gender` | "male" &#124; "female" |

**Returns:** *void*

___

###  setEnergy

▸ **setEnergy**(`energy`: number): *void*

**Parameters:**

Name | Type |
------ | ------ |
`energy` | number |

**Returns:** *void*

___

###  setMemberDebug

▸ **setMemberDebug**(): *void*

**Returns:** *void*

___

###  setMembership

▸ **setMembership**(`player`: [Player](_player_d_.player.md), `member`: boolean): *void*

**Parameters:**

Name | Type |
------ | ------ |
`player` | [Player](_player_d_.player.md) |
`member` | boolean |

**Returns:** *void*

___

###  setParentEmail

▸ **setParentEmail**(`email`: string): *void*

**Parameters:**

Name | Type |
------ | ------ |
`email` | string |

**Returns:** *void*

___

###  setPlayerClass

▸ **setPlayerClass**(`playerClass`: unknown): *void*

**Parameters:**

Name | Type |
------ | ------ |
`playerClass` | unknown |

**Returns:** *void*

___

###  setSFXVolume

▸ **setSFXVolume**(`volume`: number): *void*

**Parameters:**

Name | Type |
------ | ------ |
`volume` | number |

**Returns:** *void*

___

###  setSpinDate

▸ **setSpinDate**(`date`: Date): *void*

**Parameters:**

Name | Type |
------ | ------ |
`date` | Date |

**Returns:** *void*

___

###  setVoiceVolume

▸ **setVoiceVolume**(`volume`: number): *void*

**Parameters:**

Name | Type |
------ | ------ |
`volume` | number |

**Returns:** *void*

___

###  setZone

▸ **setZone**(`zone`: unknown): *void*

**Parameters:**

Name | Type |
------ | ------ |
`zone` | unknown |

**Returns:** *void*

___

###  spinWheel

▸ **spinWheel**(`wheel`: 1 | 2): *void*

**Parameters:**

Name | Type |
------ | ------ |
`wheel` | 1 &#124; 2 |

**Returns:** *void*

___

###  swapSpells

▸ **swapSpells**(`prop0`: unknown, `prop1`: unknown): *unknown*

**Parameters:**

Name | Type |
------ | ------ |
`prop0` | unknown |
`prop1` | unknown |

**Returns:** *unknown*

___

###  transformPlayer

▸ **transformPlayer**(`prop0`: unknown, `prop1`: unknown, `prop2`: number): *void*

**Parameters:**

Name | Type |
------ | ------ |
`prop0` | unknown |
`prop1` | unknown |
`prop2` | number |

**Returns:** *void*

___

###  unequip

▸ **unequip**(`type`: [ItemType](../modules/_player_d_.md#itemtype)): *boolean*

**Parameters:**

Name | Type |
------ | ------ |
`type` | [ItemType](../modules/_player_d_.md#itemtype) |

**Returns:** *boolean*

___

###  updateMembershipVideoAdData

▸ **updateMembershipVideoAdData**(): *void*

**Returns:** *void*

___

###  updateModifier

▸ **updateModifier**(`type`: "potion" | "barrier", `modifier`: number): *void*

**Parameters:**

Name | Type |
------ | ------ |
`type` | "potion" &#124; "barrier" |
`modifier` | number |

**Returns:** *void*

___

###  validateLevel

▸ **validateLevel**(): *void*

**Returns:** *void*

___

### `Static` enemiesPerLevel

▸ **enemiesPerLevel**(`level`: number): *number*

**Parameters:**

Name | Type |
------ | ------ |
`level` | number |

**Returns:** *number*

___

### `Static` getAoeEvolutions

▸ **getAoeEvolutions**(): *number[]*

**Returns:** *number[]*

___

### `Static` getAttacksFromCurve

▸ **getAttacksFromCurve**(`prop0`: unknown[], `prop1`: number, `prop2`: number): *unknown[]*

**Parameters:**

Name | Type |
------ | ------ |
`prop0` | unknown[] |
`prop1` | number |
`prop2` | number |

**Returns:** *unknown[]*

___

### `Static` getAttacksOfType

▸ **getAttacksOfType**(`prop0`: unknown, `prop1`: unknown): *unknown[]*

**Parameters:**

Name | Type |
------ | ------ |
`prop0` | unknown |
`prop1` | unknown |

**Returns:** *unknown[]*

___

### `Static` getEvolutionsFromCurve

▸ **getEvolutionsFromCurve**(`prop0`: unknown[], `prop1`: number, `prop2`: number): *unknown[]*

**Parameters:**

Name | Type |
------ | ------ |
`prop0` | unknown[] |
`prop1` | number |
`prop2` | number |

**Returns:** *unknown[]*

___

### `Static` getHeartsFromCurve

▸ **getHeartsFromCurve**(`prop0`: unknown[], `prop1`: number, `prop2`: number): *number*

**Parameters:**

Name | Type |
------ | ------ |
`prop0` | unknown[] |
`prop1` | number |
`prop2` | number |

**Returns:** *number*

___

### `Static` getLevelPercent

▸ **getLevelPercent**(`stars`: number): *number*

**Parameters:**

Name | Type |
------ | ------ |
`stars` | number |

**Returns:** *number*

___

### `Static` getSingleShotEvolutions

▸ **getSingleShotEvolutions**(): *number[]*

**Returns:** *number[]*

___

### `Static` levelFromStars

▸ **levelFromStars**(`stars`: number): *number*

**Parameters:**

Name | Type |
------ | ------ |
`stars` | number |

**Returns:** *number*

___

### `Static` starsToLevel

▸ **starsToLevel**(`stars`: number): *number*

**Parameters:**

Name | Type |
------ | ------ |
`stars` | number |

**Returns:** *number*
